/*
   Siag, Scheme In A Grid
   Copyright (C) 2000  Ulric Eriksson <ulric@siag.nu>
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
 */

#include "../config.h"

#ifdef HAVE_LIBMYSQLCLIENT

/* Highly experimental! */

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include "../siod/siod.h"
#include "calc.h"

static char *host = "127.0.0.1";
static char *database = "siag";
static char *user = "siag";
static char *password = "siag";

#define FAIL(m, p) {\
	fprintf(stderr, "error '%s': %s\n", p, mysql_error(m));\
	return NIL;\
}

static LISP store_result(buffer *buf, int sht, int row, int col, MYSQL *mysql)
{
	int i, n;
	cval val;
	char *p;
	LISP res = NIL;
	MYSQL_RES *mysql_res;
	MYSQL_FIELD *mysql_field;
	MYSQL_ROW mysql_row;

	val.number = 0;
	if (mysql == NULL) FAIL(mysql, "mysql is null");
	mysql_res = mysql_store_result(mysql);
	n = mysql_field_count(mysql);
	if (n == 0) FAIL(mysql, "no columns in result");

	while ((mysql_row = mysql_fetch_row(mysql_res))) {
		for (i = 0; i < n; i++) {
			p = (char *)mysql_row[i];
			if (res == NIL) {
				res = strcons(strlen(p), p);
			} else {
				ins_data(buf, siod_interpreter,
					p, val, MTEXT, sht, row, col+i);
			}
		}
		row++;
	}
	mysql_free_result(mysql_res);
	return res;
}

static LISP lmysql_query(LISP query)
{
	int row, col, sht;
	buffer *buf;
	char *q = get_c_string(query);
	MYSQL mysql;
	LISP res;

	get_siod_coords(&row, &col, &sht, &buf);
	mysql_init(&mysql);
	if (!mysql_real_connect(&mysql, host, user, password,
				database, 0, NULL, 0))
		FAIL(&mysql, "connect");

	if (mysql_real_query(&mysql, q, strlen(q)))
		FAIL(&mysql, "query");
	res = store_result(buf, sht, row, col, &mysql);
	mysql_close(&mysql);
	return res;
}

void init_mysql(void)
{
	init_subr_1("mysql_query", lmysql_query);
}

#else

void init_mysql(void)
{
	;
}

#endif	/* MYSQL */

